import jp.jig.jiglet.*;

public class SearchEngine extends Jiglet {
	static final int SP_LENGTH = 1024;
	//GWO
	static String[] seName = new String[] {
		"Google",
		"Yahoo",
		"",
		"Google{ꌟ",
		"Googlej[X",
		"Googleꔭ",
		"GoogleC[W",
		"Ask",
		"yV",
		"ITpꌟ",
		"͂ĂȌ",
		"Wikipedia",
		"JWord",
		"2ch",
		"goouO",
	};
	//GWURL
	static String[] sePrefix = new String[] {
		"http://www.google.com/search?hl=ja&lr=&num=50&q=",
		"http://search.yahoo.co.jp/bin/search?fr=top&p=",
		"http://quote.yahoo.co.jp/q?d=c&k=c3&h=on&z=m&s=",
		"http://www.google.com/search?hl=ja&num=50&lr=lang_ja&q=",
		"http://news.google.co.jp/news?hl=ja&ned=jp&q=",
		"http://www.google.com/search?btnI=I%27m+Feeling+Lucky&lr=lang_ja&q=",
		"http://images.google.com/images?hl=ja&ie=UTF-8&oe=UTF-8&q=",
		"http://ask.jp/web.asp?o=0&qsrc=3&ln=ja&q=",
		"http://esearch.rakuten.co.jp/rms/sd/esearch/vc?sv=2&sitem=",
		"http://e-words.jp/?w=",
		"http://search.hatena.ne.jp/keyword?word=",
		"http://ja.wikipedia.org/wiki/:Search?search=",
		"http://search.jword.jp/cns.dll?lang=sjis&name=",
		"http://find.2ch.net/?BBS=ALL&TYPE=TITLE&COUNT=50&STR=",
		"http://blog.goo.ne.jp/search/search.php?status=select&tg=all&dc=50&dp=all&st=time&ts=all&da=all&MT=",
	};
	//GWGR[h
	static int[] seEncoding = new int[] {
		ENCODE_UTF8,
		ENCODE_UTF8,
		ENCODE_EUC,
		ENCODE_UTF8,
		ENCODE_UTF8,
		ENCODE_UTF8,
		ENCODE_UTF8,
		ENCODE_UTF8,
		ENCODE_EUC,
		ENCODE_SJIS,
		ENCODE_EUC,
		ENCODE_UTF8,
		ENCODE_SJIS,
		ENCODE_EUC,
		ENCODE_EUC,
	};
	
	//ϐ
	String[] keywordList;		//܂łɓ͂ꂽL[[hꗗ
	
	//ẼJ[\Aѕ\ʒu
	int leftCursor;
	int leftOffset;
	int rightCursor;
	int rightOffset;
	
	//
	int state = 0;
	
	int fontH = 12;
	
	public void main() {
		setSoftLabel("I");
		
		setMenu(new String[] {"[h폜",}, new String[]{"͂[hSč폜܂"});
		
		readKeywordList();
		clearKey();
		state = 1;
		
		int row = (DH - 6) / (fontH + 2);
		int key = 0;
		for (;;) {
			if (key >= 0) {
				repaint();
			}
			sleep(20);
			
			key = getKey();
			if (key == KEY_SOFT) {
				terminate();
			}
			if ((key & 0xFF0000) == EVENT_MENU) {
				//L[[h폜
				int index = key & 0xFFFF;
				keywordList = new String[] {"VK"};
				writeKeywordList();
				rightCursor = 0;
				rightOffset = 0;
			}
			
			if (state == 1) {		//GWI𕔕
				int len = seName.length;
				if (key == KEY_UP) {
					leftCursor = (leftCursor - 1 + len) % len;
				} else if (key == KEY_DOWN) {
					leftCursor = (leftCursor + 1) % len;
				}
				if (leftOffset > leftCursor) {
					leftOffset = leftCursor;
				}
				if (leftOffset <= leftCursor - row) {
					leftOffset = leftCursor - row + 1;
				}
				if (leftOffset < 0) {
					leftOffset = 0;
				}
				if (key == KEY_SELECT || key == KEY_RIGHT) {
					state = 2;
				}
			} else if (state == 2) {		//L[[hI𕔕
				int len = keywordList.length;
				if (key == KEY_UP) {
					rightCursor = (rightCursor - 1 + len) % len;
				} else if (key == KEY_DOWN) {
					rightCursor = (rightCursor + 1) % len;
				}
				if (rightOffset > rightCursor) {
					rightOffset = rightCursor;
				}
				if (rightOffset <= rightCursor - row) {
					rightOffset = rightCursor - row + 1;
				}
				if (rightOffset < 0) {
					rightOffset = 0;
				}
				if (key == KEY_LEFT || key == KEY_IAPP) {
					state = 1;
				}
				if (key == KEY_SELECT) {
					String str = "";
					if (rightCursor > 0) {
						str = keywordList[rightCursor];
					}
					str = inputText(str, TEXT_KANA);
					if (str != null && str.length() > 0) {
						int idx = -1;
						for (int i = 1; i < keywordList.length; i++) {
							if (keywordList[i].equals(str)) {
								idx = i;
								break;
							}
						}
						if (idx >= 0) {
							for (int i = idx; i > 1; i--) {
								keywordList[i] = keywordList[i - 1];
							}
							keywordList[1] = str;
						} else {
							String[] dum = keywordList;
							keywordList = new String[dum.length + 1];
							keywordList[0] = dum[0];
							keywordList[1] = str;
							for (int i = 1; i < dum.length; i++) {
								keywordList[i + 1] = dum[i];
							}
						}
						writeKeywordList();
						rightCursor = 0;
						rightOffset = 0;
						state = 1;
						launch(sePrefix[leftCursor] + encodeURL(str), seEncoding[leftCursor], 0);
					}
				}
			}
		}
	}
	
	//L[[hXNb`pbhǂݍ
	void readKeywordList() {
		byte[] sp = readSP(0, SP_LENGTH);
		int p = 0;
		int num = (sp[p++] & 0xFF);
		keywordList = new String[num + 1];
		
		keywordList[0] = "VK";
		for (int i = 1; i < keywordList.length; i++) {
			num = (sp[p++] & 0xFF);
			keywordList[i] = new String(sp, p, num);
			p += num;
		}
	}
	//XNb`pbhɃL[[h
	void writeKeywordList() {
		for (int max = keywordList.length; max > 0; max--) {
			byte[] sp = new byte[SP_LENGTH + 1024];
			int p = 1;
			int num = 0;
			for (int i = 1; i < max; i++) {
				byte[] b = keywordList[i].getBytes();
				if (b.length < 256) {
					sp[p++] = (byte)(b.length);
					arraycopy(b, 0, sp, p, b.length);
					p += b.length;
					num++;
					if (p > SP_LENGTH) {
						break;
					}
				}
			}
			if (p <= SP_LENGTH) {		//eʈȓ珑
				sp[0] = (byte)num;
				byte[] ret = new byte[SP_LENGTH];
				arraycopy(sp, 0, ret, 0, SP_LENGTH);
				writeSP(0, ret);
				return;
			}
		}
	}
	
	//`惁\bh
	public void paint(boolean allDrawFlag) {
		if (state <= 0) {	//IOɌĂяoꂽꍇ͂ȂɂȂ
			return;
		}
		setFont(0);
		fontH = getFontHeight();
		int fh = fontH;
		
		setColor(255, 255, 255);
		fillRect(0, 0, DW, DH);
		
		int w = DW / 2 - 1;
		int x = 3;
		int y = 3;
		draw3DRect(0, 0, w, DH);
		//GWꗗ`
		for (int i = leftOffset; i < seName.length; i++) {
			if (i == leftCursor) {
				if (state == 1) {
					setColor(0, 0, 255);
				} else {
					setColor(200, 200, 200);
				}
				fillRect(x - 1, y, w + 2, fh + 2);
				setColor(255, 255, 255);
			} else {
				setColor(0, 0, 0);
			}
			drawString(seName[i], x, y + fh);
			y += fh + 2;
			if (y + fh >= DH) {
				break;
			}
		}
		//L[[hꗗ`
		draw3DRect(DW / 2, 0, w, DH);
		x = DW / 2 + 3;
		y = 3;
		
		for (int i = rightOffset; i < keywordList.length; i++) {
			if (i == rightCursor && state == 2) {
				setColor(0, 0, 255);
				fillRect(x - 1, y, w + 2, fh + 2);
				setColor(255, 255, 255);
			} else {
				setColor(0, 0, 0);
			}
			drawString(keywordList[i], x, y + fh);
			y += fh + 2;
			if (y + fh >= DH) {
				break;
			}
		}
	}
}
